; CanDb1.TXT = Testprogramm fuer "UPT"-Entwicklung  mit   "CANdb-Signalen" .
;  Ablage: <WoBu3> C:\CBproj\CanTest\Programs\IPEview.TXT .
;  Stand:  2002-04-12 (yyyy-mm-dd)
;    ERSETZT irgendein ominoeses Geraet welches CAN-"MESSAGES" nach "CAN-DB-Format"
;    sendet.
;    Lauffaehig nur mit CAN-Tester fuer WINDOZE ab Januar 2002 !!
;

$601 01 02 03 04 05 06 07 08  ; CAN-Interface 1
$000 08 07 06 05 04 03 02 01  ; CAN-Interface 2

CanLogLoop:
$601  ; very short frame to test the CAN LOGGER INTERRUPT 
$3FF  ; a telegram which should be logged (for testing)
$3FE  ; another telegram which should be logged
$3FD  ; another telegram which should be logged
$555  ; a very short telegram (almost no bitstuffing, no data)
$777  ; a telegram which shall not be logged at all (-> interrupt but telegram thrown away)
@goto CanLogLoop


@gosub SetWatches


; Some "CANdb test signals" .. don't ask where they come from ;-)
; "TOEL": Bus1, ID=0x0000D3, MOTOROLA, 16 bit, LSB at bit 39??????!?!?!??????!??!?

@N=0:@H=0
L1:  ;-- emulate some "CAN db" - messages with (N) signals....... holy shit
 ; $0000C 01 02 03 04 05 06 07 08 
 $000D3 (H).mw (H).mw (H).mw (H).mw  ; Suffix ".mw" = MOTOROLA word (MSB first)
 @N=N+1:@H=H+10
@goto L1


; CAN-ID 0x0D3 enthaelt vier 116-bit Signale im MOTOROLA-FORMAT (MSB first):
;              TL_0,    TL_1RS,      TOEL,    TKW .
;              Faktor: 0.019, Offset: 575.01,  Min=-50, Max=1200, Einheit=C
$00D3 (     0).mw (     0).mw (     0).mw (     0).mw   ; ->  "575.01 C" (?)
$00D3 (     1).mw (     1).mw (     1).mw (     1).mw   ; ->  "575.03 C" (?)
$00D3 (   100).mw (   100).mw (   100).mw (   100).mw   ; ->  "576.92 C" (?!)
$00D3 ( $8000).mw ( $8000).mw ( $8000).mw ( $8000).mw   ; ->  "-50.00 C" 
$00D3 ( $FFFF).mw ( $FFFF).mw ( $FFFF).mw ( $FFFF).mw   ; ->  "574.99 C" 
$00D3 (-30147).mw (-30147).mw (-30147).mw (-30147).mw   ; ->  " -0.01 C"
L2:
 $00D3 (T).mw (T).mw (T).mw (T-10000).mw         ; TL_0,   TL_1RS, TOEL,   TKW
 $00DE (T).mw (T).mw (-29000+(T/100)).mw (T).mw  ; T_vUBK, T_nUBK, TL_amb, Thermo2_8
 @T=(T+1000) & $0FFFF
@goto L2

; CAN-BUS #2 ( NUMERO DUE !! ),  CAN-ID #1365 .....
;              enthaelt ein 14-bit(!) Signal im MOTOROLA-FORMAT (MSB first)
;              aus einem Beispiel in VEKTOR's CANdb++ EDITOR HELP SYSTEM.
;              Das LEAST SIGNIFICANT BIT liegt an Bitposition 21 im CAN-Telegramm,
;              das MOST  SIGNIFICANT BIT liegt an Bitposition  4 (!) .
;       Das ekelhafte Kuddelmuddel dieses auf DREI BYTES(!) verteilten 14-bit(!)-Signals
;       kann per CAN-Tester kaum nachgebildet werden, darum einzelne Telegramme:       
#1365 00 00 00 00 00 00 00 00        ; ->      0
#1365 1F FF 80 00 00 00 00 00        ; ->     -1 (alle Datenbits "1" ! ! )




; CAN-ID 0x555 dient zum Testen einer 14-Bit-Integer-Zahl im MOTOROLA-FORMAT (MSB first),
;              stammt aus Beispiel von Vector's "CANdb++ Editor". 
;              Das MSBit an Position 23, wird bei Vektor irrefuehrenderweise 
;                                        "Startposition" genannt .
$00555 E0 00 7F FF FF FF FF FF  ; 14-Bit MOTOROLA-Integer mit MSBit-Pos 23 : muss 0 ergeben
$00555 FF FF FF FF FF FF FF FF  ; 14-Bit MOTOROLA-Integer mit MSBit-Pos 23 : muss -1 ergeben
$00555 1F FF 80 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit MSBit-Pos 23 : ebenfalls -1
$00555 00 00 80 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit MSBit-Pos 23 : -> 1 
$00555 00 01 00 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit MSBit-Pos 23 : -> 2
$00555 00 02 00 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit MSBit-Pos 23 : -> 4
$00555 00 04 00 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit MSBit-Pos 23 : -> 8
$00555 00 80 00 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit MSBit-Pos 23 : -> 256
$00555 01 00 00 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit MSBit-Pos 23 : -> 512
$00555 02 00 00 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit MSBit-Pos 23 : -> 1024
$00555 04 00 00 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit MSBit-Pos 23 : -> 2048
$00555 08 00 00 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit MSBit-Pos 23 : -> 4096
$00555 10 00 00 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit MSBit-Pos 23 : -> -(!) 8192
$00555 0F FF 80 00 00 00 00 00  ; 14-Bit MOTOROLA-Integer mit MSBit-Pos 23 : -> 8191

$07FF.s 01 02 03 04 05 06 07 08
$07FF.x 01 02 03 04 05 06 07 08
$000 01 02 03 04
$601 00 00 00 00

;---------- some "watches" ---------------------------------------------------
SetWatches:
@def_watch(1).name  SDO-Write CH1
@def_watch(1).event (#1538) 0 8 2B xx xx xx xx xx xx xx
@def_watch(1).expr  hl(rx.d1, rx.d0)  ; 16 - bit  Index
@def_watch(1).format U=%ld
@def_watch(1).action a
@set_scope(1).range -32768, 32768       ; Scope-Messbereich passend zur Watch

@def_watch(2).name  SDO-Write CH2
@def_watch(2).event (#1539) 0 8 2B xx xx xx xx xx xx xx
@def_watch(2).expr  hl(rx.d1, rx.d0)  ; 16 - bit  Index
@def_watch(2).format U=%ld
@def_watch(2).action @sound(100,200,5)
@set_scope(2).range -32768, 32768       ; Scope-Messbereich passend zur Watch

@return

